VERSION 5.00
Begin VB.Form frmDemo 
   Caption         =   "DataMatrix Font Demo"
   ClientHeight    =   7665
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9120
   LinkTopic       =   "Form1"
   ScaleHeight     =   7665
   ScaleWidth      =   9120
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cbxFontSize 
      Height          =   315
      ItemData        =   "frmDemo.frx":0000
      Left            =   1680
      List            =   "frmDemo.frx":0022
      TabIndex        =   4
      Top             =   2400
      Width           =   1575
   End
   Begin VB.CheckBox chkHandleTilde 
      Alignment       =   1  'Right Justify
      Caption         =   "Process Tilde"
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   1896
      Width           =   1695
   End
   Begin VB.ComboBox cbxPreferredFormat 
      Height          =   315
      ItemData        =   "frmDemo.frx":004C
      Left            =   1680
      List            =   "frmDemo.frx":00AD
      TabIndex        =   2
      Top             =   1334
      Width           =   2415
   End
   Begin VB.ComboBox cbxMode 
      Height          =   315
      ItemData        =   "frmDemo.frx":0220
      Left            =   1680
      List            =   "frmDemo.frx":0233
      TabIndex        =   1
      Top             =   772
      Width           =   2415
   End
   Begin VB.TextBox txtMessage 
      Height          =   285
      Left            =   1680
      TabIndex        =   0
      Text            =   "1234"
      Top             =   240
      Width           =   4575
   End
   Begin VB.CommandButton cmdPrint 
      Caption         =   "Print DataMatrix"
      Height          =   495
      Left            =   7080
      TabIndex        =   6
      Top             =   960
      Width           =   1695
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   495
      Left            =   7080
      TabIndex        =   8
      Top             =   1680
      Width           =   1695
   End
   Begin VB.CommandButton cmdDisplay 
      Caption         =   "Display DataMatrix"
      Height          =   495
      Left            =   7080
      TabIndex        =   5
      Top             =   240
      Width           =   1695
   End
   Begin VB.TextBox txtDataMatrix 
      Alignment       =   2  'Center
      Height          =   4455
      Left            =   240
      MultiLine       =   -1  'True
      TabIndex        =   7
      Top             =   2880
      Width           =   8655
   End
   Begin VB.Label lblFontSize 
      Caption         =   "Font Size"
      Height          =   255
      Left            =   240
      TabIndex        =   12
      Top             =   2400
      Width           =   1095
   End
   Begin VB.Label lblPreferredFormat 
      Caption         =   "Preferred Format"
      Height          =   255
      Left            =   240
      TabIndex        =   11
      Top             =   1320
      Width           =   1335
   End
   Begin VB.Label lblMode 
      Caption         =   "Mode"
      Height          =   255
      Left            =   240
      TabIndex        =   10
      Top             =   780
      Width           =   855
   End
   Begin VB.Label lblMessage 
      Caption         =   "Message"
      Height          =   255
      Left            =   240
      TabIndex        =   9
      Top             =   240
      Width           =   735
   End
End
Attribute VB_Name = "frmDemo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Sub DMEncode Lib "DataMatrixFont.dll" _
(ByVal Message As String, ByVal Mode As Byte, ByVal PreferredFormat As Byte, ByVal HandleTilde As Boolean)

Private Declare Function DMGetRows Lib "DataMatrixFont.dll" () As Integer
Private Declare Function DMGetCols Lib "DataMatrixFont.dll" () As Integer
Private Declare Function DMGetCharAt Lib "DataMatrixFont.dll" (ByVal RowIndex As Integer, ByVal ColIndex As Integer) As Integer

Private Sub cmdDisplay_Click()
    Dim Message As String
    Dim Mode As Byte
    Dim PreferredFormat As Byte
    Dim RowCount As Integer
    Dim ColCount As Integer
    Dim HandleTilde As Boolean

    On Error GoTo ErrorHandler
    
    ' Message
    Message = txtMessage.Text

    ' 0 for AUTO mode, 1 for ASCII mode, 2 for C40 mode, 3 for Text mode, 4 for Base256 mode
    Mode = cbxMode.ListIndex

    ' Preferred format
    PreferredFormat = cbxPreferredFormat.ListIndex

    ' Handle tilde or not?
    HandleTilde = chkHandleTilde.Value

    ' Encode data using DataMatrix
    Call DMEncode(Message, Mode, PreferredFormat, HandleTilde)

    txtDataMatrix.Text = ""
    txtDataMatrix.FontName = "MW6 Matrix"
    txtDataMatrix.FontSize = CInt(cbxFontSize.Text)
    
    ' How many rows?
    RowCount = DMGetRows
    
    ' How many characters in one row?
    ColCount = DMGetCols
    
    ' Produce string for DataMatrix font
    EncodedMsg = vbCrLf
    For I = 1 To RowCount
        For J = 1 To ColCount
            EncodedMsg = EncodedMsg & Chr(DMGetCharAt(I - 1, J - 1))
        Next J
        EncodedMsg = EncodedMsg & vbCrLf
    Next I
    txtDataMatrix.Text = EncodedMsg
    
    Exit Sub
    
ErrorHandler:

End Sub

Private Sub cmdPrint_Click()
    Dim Message As String
    Dim Mode As Byte
    Dim PreferredFormat As Byte
    Dim RowCount As Integer
    Dim ColCount As Integer
    Dim HandleTilde As Boolean

    On Error GoTo ErrorHandler
    
    ' Message
    Message = txtMessage.Text

    ' 0 for AUTO mode, 1 for ASCII mode, 2 for C40 mode, 3 for Text mode, 4 for Base256 mode
    Mode = cbxMode.ListIndex

    ' Preferred format
    PreferredFormat = cbxPreferredFormat.ListIndex

    ' Handle tilde or not?
    HandleTilde = chkHandleTilde.Value

    ' Encode data using DataMatrix
    Call DMEncode(Message, Mode, PreferredFormat, HandleTilde)

    txtDataMatrix.Text = ""
    txtDataMatrix.FontName = "MW6 Matrix"
    txtDataMatrix.FontSize = CInt(cbxFontSize.Text)
    
    ' How many rows?
    RowCount = DMGetRows
    
    ' How many characters in one row?
    ColCount = DMGetCols
    
    ' Produce string for DataMatrix font
    Printer.CurrentX = 600
    Printer.CurrentY = 800
    
    ' Print all rows using DataMatrix font
    For I = 1 To RowCount
        OneLine = ""
        For J = 1 To ColCount
            OneLine = OneLine & Chr(DMGetCharAt(I - 1, J - 1))
        Next J
        ' Print one line using DataMatrix font
        Printer.Print OneLine
        Printer.CurrentX = 600
    Next I
    Printer.EndDoc
    
    Exit Sub
    
ErrorHandler:

End Sub

Private Sub Form_Load()
    cbxPreferredFormat.ListIndex = 0
    cbxFontSize.ListIndex = 6
    cbxMode.ListIndex = 0
End Sub

Private Sub cmdExit_Click()
    Unload Me
End Sub
